"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogicalExpression = void 0;
const Domain_1 = require("@/NCalc/Domain");
class LogicalExpression {
    constructor() { }
    And(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.And, this, new Domain_1.ValueExpression(operand));
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.And, this, operand);
        }
    }
    DividedBy(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Div, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Div, this, new Domain_1.ValueExpression(operand));
        }
    }
    EqualsTo(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Equal, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Equal, this, new Domain_1.ValueExpression(operand));
        }
    }
    GreaterThan(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Greater, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Greater, this, new Domain_1.ValueExpression(operand));
        }
    }
    GreaterOrEqualThan(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.GreaterOrEqual, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.GreaterOrEqual, this, new Domain_1.ValueExpression(operand));
        }
    }
    LesserThan(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Lesser, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Lesser, this, new Domain_1.ValueExpression(operand));
        }
    }
    LesserOrEqualThan(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.LesserOrEqual, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.LesserOrEqual, this, new Domain_1.ValueExpression(operand));
        }
    }
    Minus(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Minus, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Minus, this, new Domain_1.ValueExpression(operand));
        }
    }
    Modulo(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Modulo, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Modulo, this, new Domain_1.ValueExpression(operand));
        }
    }
    NotEqual(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.NotEqual, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.NotEqual, this, new Domain_1.ValueExpression(operand));
        }
    }
    Or(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Or, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Or, this, new Domain_1.ValueExpression(operand));
        }
    }
    Plus(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Plus, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Plus, this, new Domain_1.ValueExpression(operand));
        }
    }
    Mult(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Plus, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.Plus, this, new Domain_1.ValueExpression(operand));
        }
    }
    BitwiseOr(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.BitwiseOr, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.BitwiseOr, this, new Domain_1.ValueExpression(operand));
        }
    }
    BitwiseAnd(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.BitwiseAnd, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.BitwiseAnd, this, new Domain_1.ValueExpression(operand));
        }
    }
    BitwiseXOr(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.BitwiseXOr, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.BitwiseXOr, this, new Domain_1.ValueExpression(operand));
        }
    }
    LeftShift(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.LeftShift, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.LeftShift, this, new Domain_1.ValueExpression(operand));
        }
    }
    RightShift(operand) {
        if (operand.constructor.name === "LogicalExpression") {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.RightShift, this, operand);
        }
        else {
            return new Domain_1.BinaryExpression(Domain_1.BinaryExpressionType.RightShift, this, new Domain_1.ValueExpression(operand));
        }
    }
    ToString() {
        const serializer = new Domain_1.SerializationVisitor();
        this.Accept(serializer);
        return serializer.Result.join("").trim();
    }
    Accept(visitor) {
        visitor.Visit(this);
    }
}
exports.LogicalExpression = LogicalExpression;
