"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EvaluateOptions = void 0;
var EvaluateOptions;
(function (EvaluateOptions) {
    // Summary:
    //     Specifies that no options are set.
    EvaluateOptions[EvaluateOptions["None"] = 1] = "None";
    //
    // Summary:
    //     Specifies case-insensitive matching.
    EvaluateOptions[EvaluateOptions["IgnoreCase"] = 2] = "IgnoreCase";
    //
    // Summary:
    //     No-cache mode. Ingores any pre-compiled expression in the cache.
    EvaluateOptions[EvaluateOptions["NoCache"] = 4] = "NoCache";
    //
    // Summary:
    //     Treats parameters as arrays and result a set of results.
    EvaluateOptions[EvaluateOptions["IterateParameters"] = 8] = "IterateParameters";
    //
    // Summary:
    //     When using Round(), if a number is halfway between two others, it is rounded toward the nearest number that is away from zero.
    EvaluateOptions[EvaluateOptions["RoundAwayFromZero"] = 16] = "RoundAwayFromZero";
})(EvaluateOptions = exports.EvaluateOptions || (exports.EvaluateOptions = {}));
